



*Import all those sweet AYP csv files into stata
forvalues y=2004/2008 {
	clear
	
	*Some fool in 2005 decided they wanted to be cute and change the name of the AYP status variable
	if `y'==2004 {
		local name status
	}
	if `y'==2005 {
		local name final
	}
	if `y'==2006 {
		local name status
	}
	if `y'==2007 {
		local name status
	}
	if `y'==2008 {
		local name status
	}
	
	*import the AYP csv files
	import delimited using ${Projectfolder}/AYPdata/CAMPALL`y'.csv, delim(",") varn(1)
	compress
	*only need campus number and AYP status
	keep campus c_`name'
	*make year variable
	gen year=`y'
	*code up an AYP status indicator
	gen meetsAYP=.
	replace meetsAYP=0 if c_`name'=="N"
	replace meetsAYP=1 if c_`name'=="Y"
	replace meetsAYP=2 if c_`name'=="X"
	
	label define meetsAYP 0 "Missed AYP Attendance", modify
	label define meetsAYP 1 "Meets AYP", modify
	label define meetsAYP 2 "Not Evaluated", modify
	label values meetsAYP meetsAYP
	
	drop c_`name'
	
	tempfile AYP`y'
	save `AYP`y'', replace
	
	}
	

*Appdend all those sweet AYP tempfiles together
use `AYP2004'
forvalues y=2005/2008 {
	append using `AYP`y''
}

*make sure all years are populated
tab year

*double check to make sure there aren't any duplicate campuses in any year
duplicates tag campus year, gen(temp1)
drop if temp1>0
drop temp1

*save that sweet AYP panel
saveold ${Projectfolder}/AYPdata/AYP2004_2008, replace
