*This file takes the estimation sample and creates connected networks of principals

clear all
set more off
set maxvar 32767
set matsize 11000
capture log close _all

global working_dir	${Projectfolder}/work_files/
global account_dir	${Projectfolder}/account_rating/
global staff_dir	${project_data}/Projectfolder/tea/peims/staff/
global rdd_output	${working_dir}/rdd_output/
global LPM_success	${working_dir}/LPM_success/


****This is an old section of code when we were restricting our connected networks to just principals from 01-08****
/*start with the sample of principals 
	use ${working_dir}RDD_sample_05_2016, clear
	
	*RDD_sample_05_2016
	
	*now keep one observation per pid/ssnrep
		bys ssnrep: keep if _n==1
		
	*now just keep ssnrep
		keep ssnrep
		
	*now this file is just a list of principals in our sample
		saveold ${working_dir}princ_list, replace
*/		
	
*now get the principals_panel data
	use ${working_dir}principals_panel, clear
	
	*NO REASON FOR THE NEXT TWO LINES AFTER WE CUT OUT LINES 17-30
	*merge with princ_list and keep matches
	*merge m:1 ssnrep using ${working_dir}princ_list, nogen keep(match)
	
	*keep if year>=2001
	*keep if year>=2001 & year<=2008 
	keep if year>=1995 & year<=2008 /* Changed in winter 2019 to respond to JHR R&R letter */
	
	tab year
	
	keep if role==20

	
*start with dataset that contains princpals and the schools they are at during our sampling period
	keep ssnrep campus
	bys ssnrep campus: keep if _n==1
	
*reshape to wide 
	bys ssnrep: gen tmp=_n
	reshape wide campus, i(ssnrep) j(tmp)
	*drop ssnrep
	
*back to long format
	gen newid=_n
	reshape long campus, i(newid) j(n)
	drop if campus==.
	
*do the group_id magic
	clonevar comp=newid
	list in 20/40, sepby(comp) 
	group_id comp, match(campus)
	*Now comp is our connected network identifier and any principal that works at a particular campus will belong to the same network.
	
	preserve
		log using ${LPM_success}schools_per_network_dist.txt, replace text
		*we want the distribution of the number of schools in a connected networks
			*this data should have multiple schools per network in each year
			*I need to just keep one observation per campus for the entire panel bc i dont want the same campus to be counted more than once in each network
				bys campus: keep if _n==1
			*now make a variable that variable that counts the number of campuses per networks	
				bys comp: gen network_count=_N
			*now we only need one observation per network_count
				by comp: keep if _n==1
			*now we can summarize network_comp to get the distribution of the number of schools in a network_comp
				sum network_count, detail
		log close 				
	restore
	
*Just keep the campus and comp(contected network)
	keep campus comp
	duplicates drop campus comp, force
	
*save connected networks
	saveold ${working_dir}connected_networks, replace
	
