*predicted reading achievement from 2001 to 2008

set more off
clear

global working_dir	${Projectfolder}/account_rating/
global stud_path	${project_data}/tea/peims/student/
global taks_path	${project_data}/tea/assess/taks/
global taas_path	${project_data}/tea/assess/taas/
global camp_path	${project_data}/tea/peims/organization/campus/
global dist_path	${project_data}/tea/peims/organization/district/



*Predict average pass rates in each campus seperately by year

local grp "passred passmth atrisk gifted speced econdis title1 mover lep"

*taas
forvalues i=1(1)2 {

	use ${working_dir}/taas/taas200`i', clear
	sort campus
	*create logged student count for each campus and district
	bys campus: gen students=_N
	gen lstudents=log(students)
	bys district: gen dstudents=_N
	gen ldstudents=log(dstudents)
	
	*make ethnicity indicators
	gen black=(ethnic==3)
	gen hispanic=(ethnic==4)
	gen white=(ethnic==5)
	gen other=(ethnic!=3 & ethnic!=4 & ethnic!=5)
	
	*create campus and district passing percentages for math and reading
	bys campus: egen tot_passred=total(passred)
	bys campus: egen tot_passmth=total(passmath)
	bys campus: egen tot_takered=total(takered)
	bys campus: egen tot_takemth=total(takemath)
	bys campus: gen share_passred=(tot_passred/tot_takered)
	bys campus: gen share_passmth=(tot_passmth/tot_takemth)
	
	*creates shares for various student groups in each campus and district
	bys campus: egen share_black=mean(black)
	bys campus: egen share_hispanic=mean(hispanic)
	bys campus: egen share_white=mean(white)
	bys campus: egen share_other=mean(other)
	bys campus: egen share_atrisk=mean(atrisk)
	bys campus: egen share_gifted=mean(gifted)
	bys campus: egen share_speced=mean(speced)
	bys campus: egen share_econdis=mean(econdis)
	bys campus: egen share_title1=mean(title1)
	bys campus: egen share_mover=mean(mover)
	bys campus: egen share_lep=mean(lep)
	bys campus: egen share_male=mean(sex)
	
	keep campus district year students lstudents dstudents ldstudents share_*
	
	saveold ${working_dir}achdata_0`i', replace
	
	*collapse to campus level
	bys campus: keep if _n==1
	gen indcamp=1
	gen inddist=0
	*create average of share_passmth and share_passred
	egen share_pass=rowmean(share_passred share_passmth)
	
	saveold ${working_dir}c_achdata_0`i', replace
	
	}
	


*taks 
forvalues i=3(1)9 {

	use ${working_dir}/taks/taks200`i', clear
	sort campus
	
	*create logged student count for each campus and district
	bys campus: gen students=_N
	gen lstudents=log(students)
	bys district: gen dstudents=_N
	gen ldstudents=log(dstudents)
	
	*make ethnicity indicators
	gen black=(ethnic==3)
	gen hispanic=(ethnic==4)
	gen white=(ethnic==5)
	gen other=(ethnic!=3 & ethnic!=4 & ethnic!=5)
	
	*create campus and district passing percentages for math and reading
	bys campus: egen tot_passred=total(passred)
	bys campus: egen tot_passmth=total(passmath)
	bys campus: egen tot_takered=total(takered)
	bys campus: egen tot_takemth=total(takemath)
	bys campus: gen share_passred=(tot_passred/tot_takered)
	bys campus: gen share_passmth=(tot_passmth/tot_takemth)
	
	*creates shares for various student groups in each campus and district
	bys campus: egen share_black=mean(black)
	bys campus: egen share_hispanic=mean(hispanic)
	bys campus: egen share_white=mean(white)
	bys campus: egen share_other=mean(other)
	bys campus: egen share_atrisk=mean(atrisk)
	bys campus: egen share_gifted=mean(gifted)
	bys campus: egen share_speced=mean(speced)
	bys campus: egen share_econdis=mean(econdis)
	bys campus: egen share_title1=mean(titleone)
	bys campus: egen share_mover=mean(mover)
	bys campus: egen share_lep=mean(lep)
	bys campus: egen share_male=mean(sex)
	
	keep campus district year students lstudents dstudents ldstudents share_*
	
	saveold ${working_dir}achdata_0`i', replace
	
	*collapse to campus level
	bys campus: keep if _n==1
	gen indcamp=1
	gen inddist=0
	*create average of share_passmth and share_passred
	egen share_pass=rowmean(share_passred share_passmth)
	
	saveold ${working_dir}c_achdata_0`i', replace
	
}

forvalues i=10(1)11 {

	use ${working_dir}/taks/taks20`i', clear
	sort campus
	
	*create logged student count for each campus and district
	bys campus: gen students=_N
	gen lstudents=log(students)
	bys district: gen dstudents=_N
	gen ldstudents=log(dstudents)
	
	*make ethnicity indicators
	gen black=(ethnic==3)
	gen hispanic=(ethnic==4)
	gen white=(ethnic==5)
	gen other=(ethnic!=3 & ethnic!=4 & ethnic!=5)
	
	*create campus and district passing percentages for math and reading
	bys campus: egen tot_passred=total(passred)
	bys campus: egen tot_passmth=total(passmath)
	bys campus: egen tot_takered=total(takered)
	bys campus: egen tot_takemth=total(takemath)
	bys campus: gen share_passred=(tot_passred/tot_takered)
	bys campus: gen share_passmth=(tot_passmth/tot_takemth)
	
	*creates shares for various student groups in each campus and district
	bys campus: egen share_black=mean(black)
	bys campus: egen share_hispanic=mean(hispanic)
	bys campus: egen share_white=mean(white)
	bys campus: egen share_other=mean(other)
	bys campus: egen share_atrisk=mean(atrisk)
	bys campus: egen share_gifted=mean(gifted)
	bys campus: egen share_speced=mean(speced)
	bys campus: egen share_econdis=mean(econdis)
	bys campus: egen share_title1=mean(titleone)
	bys campus: egen share_mover=mean(mover)
	bys campus: egen share_lep=mean(lep)
	bys campus: egen share_male=mean(sex)
	
	keep campus district year students lstudents dstudents ldstudents share_*
	
	saveold ${working_dir}achdata_`i', replace
	
	*collapse to campus level
	bys campus: keep if _n==1
	gen indcamp=1
	gen inddist=0
	*create average of share_passmth and share_passred
	egen share_pass=rowmean(share_passred share_passmth)
	
	saveold ${working_dir}c_achdata_`i', replace
	
}	
	
	
*append the campus and district achievment data
	use ${working_dir}c_achdata_01, clear
	forvalues y=2/9 {
		append using ${working_dir}c_achdata_0`y'
	}
	forvalues y=10/11 {
		append using ${working_dir}c_achdata_`y'
	}
	
	sort district campus year
	
	recode year 3=2003 4=2004 5=2005 6=2006 7=2007 8=2008 9=2009 10=2010 11=2011
	
	*replace missing campus shares with zeros
	replace share_black=0    if share_black==.
	replace share_hispanic=0 if share_hispanic==.
	replace share_white=0    if share_white==.
	replace share_other=0    if share_other==.
	replace share_atrisk=0   if share_atrisk==.
	replace share_gifted=0   if share_gifted==.
	replace share_speced=0   if share_speced==.
	replace share_econdis=0  if share_econdis==.
	replace share_title1=0   if share_title1==.
	replace share_mover=0    if share_mover==.
 	replace share_lep=0      if share_lep==.
	replace share_male=0     if share_male==.
	
	*I need to add share_mover to the summary statisitcs in the principal data
	preserve
	keep campus year district share_mover
	sort campus year
	saveold ${working_dir}sharemovers, replace
	restore
		
*now make the interactions of indicators and demographic shares 
	local vargrps "atrisk gifted speced econdis title1 mover lep male"
	local ydummys "y2002 y2003 y2004 y2005 y2006 y2007 y2008 y2009 y2010 y2011"
	*campus interaction variables 
	foreach i in `vargrps' {
		gen c_share_`i'=indcamp * share_`i'
	}	
	
	*make indicators for each year
	forvalues i=2001/2011 {
		gen y`i'=(year==`i')
	}
	
*run regression
	cd ${Projectfolder}/work_files/
	areg share_pass share_male share_black share_hispanic share_white share_econdis share_title1 share_lep share_speced share_gifted share_mover `ydummys', absorb(district) vce(cluster district) 
	outreg2 using ${working_dir}workingconditins_controls2.xls, replace keep(share_male share_black share_hispanic share_white share_econdis share_title1 share_lep share_speced share_gifted share_mover y2002 y2003 y2004 y2005 y2006 y2007 y2008 y2009 y2010 y2011) 
	hjkhjkhjkkjjkh
	parmest, format(estimate) saving(predict_ach_parms, replace)
	
	predict pr_share_pass, xbd
	
	saveold ${working_dir}predict_ach_xb, replace
	
	*now I need to get the year dummy coefficients from the file of saved parameter estimates and subract them from pr_share_pass for each observation
	
	
	
	use ${Projectfolder}/work_files/predict_ach_parms, clear
	keep parm estimate
	gen group="e"
	reshape wide est, i(group) j(parm) string
	drop group
	
	saveold ${Projectfolder}/work_files/predict_ach_parms_wide, replace
	
	*we want to remove the year effects from the predictions
	use ${working_dir}predict_ach_xb, clear
	append using ${Projectfolder}/work_files/predict_ach_parms_wide
	
	local coefvars "_cons share_male share_black share_hispanic share_white share_econdis share_title1 share_lep share_speced share_gifted share_mover"
	
	foreach i in `coefvars' {
		egen est`i'=max(estimate`i')
	}
	
	drop estimate*
	drop if year==.
	
	gen predict_pass=est_cons + estshare_male*share_male + estshare_black*share_black + estshare_hispanic*share_hispanic + estshare_white*share_white ///
					 + estshare_econdis*share_econdis + estshare_title1*share_title1 + estshare_lep*share_lep + estshare_speced*share_speced + estshare_gifted*share_gifted + estshare_mover*share_mover
	
	drop if predict_pass==.
	
	*standardize predictions by year
	egen st_predict_pass=std(predict_pass)
	
	*keep relevant varaibles
	keep campus district students year predict_pass st_predict_pass share_passmth share_passred share_pass indcamp
	
	preserve
	*make weighted district averages of campus achievment
	egen distyr=group(district year)
	levelsof distyr, local(levels)
	gen d_predict_pass=.
	qui foreach l of local levels {
		summarize predict_pass [w=students] if distyr==`l'
		replace d_predict_pass=r(mean) if distyr==`l'
	}
	
	*now keep one observation for each district and year 
	*standardize weighted averages
	bys district year: keep if _n==1
	egen st_d_predict_pass=std(d_predict_pass)
	keep district year st_d_predict_pass
	rename st_d_predict_pass st_predict_pass
	gen inddist=1
	
	tempfile dist_predictions
	saveold `dist_predictions', replace
	
	restore

	append using `dist_predictions'
	
	keep campus district year st_predict_pass indcamp inddist
	
	
	*campus positions
		preserve
		keep if indcamp==1
		xtset campus year
		tsfill, full
	
		*this should handle already existing campuses
			gen long campus_1yr=campus
			gen byte indcamp_1yr=indcamp
			gen l_st_predict_pass=st_predict_pass
	
			gen long campus_2yr=campus
			gen byte indcamp_2yr=indcamp
			gen l2_st_predict_pass=st_predict_pass
		
		*Careful now, this next part might confuse you!
		*If the campus didn't exist in the year the rating was assigned then we have to look forward 1 or 2 years to get the earliest quality info for the campus
			*only need to look ahead 1 year for 1-year lags
				gen l_st_predict_pass_f1=F1.l_st_predict_pass
			*look ahead 1 and 2 years for 2 year lags
				gen l2_st_predict_pass_f1=F1.l2_st_predict_pass
				gen l2_st_predict_pass_f2=F2.l2_st_predict_pass
			*now replace the missing info with more recent years
				gen update_wc1=(l_st_predict_pass==. & l_st_predict_pass_f1!=.)
				replace l_st_predict_pass=l_st_predict_pass_f1 if l_st_predict_pass==.
				
				gen update_wc2=(l2_st_predict_pass==. & (l2_st_predict_pass_f1!=. | l2_st_predict_pass_f2!=.))
				replace l2_st_predict_pass=l2_st_predict_pass_f1 if l2_st_predict_pass==.
				replace l2_st_predict_pass=l2_st_predict_pass_f2 if l2_st_predict_pass==.
				
			*now just keep the variables you want
			keep campus* district* year st_predict_pass indcamp* inddist* l_st_predict_pass l2_st_predict_pass update_*
	
		saveold ${working_dir}pred_achievement_newc,  replace
		
		restore
	
	*district positions
		keep if inddist==1
		xtset district year
		tsfill, full
	
		*this should handle already existing districts
			gen long district_1yr=district
			gen byte inddist_1yr=inddist
			gen l_st_predict_pass=st_predict_pass
	
			gen long district_2yr=district
			gen byte inddist_2yr=inddist
			gen l2_st_predict_pass=st_predict_pass
	
		*Careful now, this next part might confuse you!
		*If the district didn't exist in the year the rating was assigned then we have to look forward 1 or 2 years to get the earliest quality info for the district
			*only need to look ahead 1 year for 1-year lags
				gen l_st_predict_pass_f1=F1.l_st_predict_pass
			*look ahead 1 and 2 years for 2 year lags
				gen l2_st_predict_pass_f1=F1.l2_st_predict_pass
				gen l2_st_predict_pass_f2=F2.l2_st_predict_pass
			*now replace the missing info with more recent years
				gen update_wc1=(l_st_predict_pass==. & l_st_predict_pass_f1!=.)
				replace l_st_predict_pass=l_st_predict_pass_f1 if l_st_predict_pass==.
				
				gen update_wc2=(l2_st_predict_pass==. & (l2_st_predict_pass_f1!=. | l2_st_predict_pass_f2!=.))
				replace l2_st_predict_pass=l2_st_predict_pass_f1 if l2_st_predict_pass==.
				replace l2_st_predict_pass=l2_st_predict_pass_f2 if l2_st_predict_pass==.
				
			*now just keep the variables you want
			keep campus* district* year st_predict_pass indcamp* inddist* l_st_predict_pass l2_st_predict_pass update_*
	
		saveold ${working_dir}pred_achievement_newd,  replace

	


