clear all

**************************************************************************************
*Name: ratings.do
*Description: Creates an file that tracks campuses and lagged accountability ratings by year so we can evaluate RDs for 2year unacceptable campuses
*Author: Gregory Phelan
**************************************************************************************

set more off
clear

global working_dir	${Projectfolder}/account_rating/


forvalues i=0(1)2 {
use ${erc_data}/non_erc/public/AEIS/campus/aeiscamp200`i', clear

*keep relevant pass rates and other variables 
keep campus c_rating 

*create c_rating2 variable
gen long c_rating2=.
replace c_rating2=100 if c_rating=="L"	
replace c_rating2=101 if c_rating=="A"	
replace c_rating2=102 if c_rating=="R"	
replace c_rating2=103 if c_rating=="E"	
label variable c_rating2 "Campus Accountability Rating"	
drop if c_rating2==.

gen long year=200`i'

recast long campus

saveold ${working_dir}ratings_`i', replace
}


forvalues i=4(1)8 {
use ${erc_data}/non_erc/public/AEIS/campus/aeiscamp200`i', clear

*keep relevant pass rates and other variables 
keep campus c_rating 

*create c_rating2 variable
gen long c_rating2=.
replace c_rating2=100 if c_rating=="L"	
replace c_rating2=101 if c_rating=="A"	
replace c_rating2=102 if c_rating=="R"	
replace c_rating2=103 if c_rating=="E"	
label variable c_rating2 "Campus Accountability Rating"	
drop if c_rating2==.

gen long year=200`i'

recast long campus

saveold ${working_dir}ratings_`i', replace
}

use ${working_dir}ratings_0, clear
append using ${working_dir}ratings_1
append using ${working_dir}ratings_2
append using ${working_dir}ratings_4
append using ${working_dir}ratings_5
append using ${working_dir}ratings_6
append using ${working_dir}ratings_7
append using ${working_dir}ratings_8

xtset campus year
sort campus year
by campus: gen c_rating2_1=L1.c_rating2
by campus: replace c_rating2_1=c_rating2[_n-1] if year==2004 & year[_n-1]==2002

keep campus year c_rating2_1

saveold ${working_dir}ratings_all, replace
