*Make new average s-b-y VA averages

clear all
set more off
set maxvar 32767
set matsize 11000
capture log close _all

global working_dir	${Projectfolder}/work_files/
global account_dir	${Projectfolder}/account_rating/
global staff_dir	${project_data}/tea/peims/staff/
global rdd_output	${working_dir}/RDDout/
global LPM_success	${working_dir}/LPM_success/





*load data
	use ${Projectfolder}/work_files/sbyfes_gp.dta, clear


*the goal is to create averages for each principal-school spell excluding their first and last years of the spell
	tab FYS_flag LYS_flag
	*FYS_flag is an indicator for the first year of the spell, LYS_flag indicates the last year of the spell
	
*make average for each principal-school
	*make duplicate sby va varaible to work with
	gen sby=asyfe3
	
	*now exclude first and last years of sby variable
	replace sby=. if FYS_flag==1
	replace sby=. if LYS_flag==1
	
	*make averages for each principal school spell
	bys newid campus: egen meansby=mean(sby)
	*meansby should only exist for principals with more than 3 years of tenure
	bys newid campus: gen tmp_count=_N
	tab tmp_count if meansby!=.
	replace meansby=. if tmp_count<3 
	
	
	*populate for all obs
	bys newid campus: egen meansby2=max(meansby)
	drop meansby
	rename meansby2 meansby
	
*now sort by newid and year and keep one observation for each
	bys campus year: keep if _n==1

*drop extra variables
	keep newid campus year meansby asyfe3 tmp_count
	
	sort campus year
	xtset campus year
	by campus: gen asyfe3_p2=F2.asyfe3
	by campus: gen asyfe3_p3=F3.asyfe3 
	
	keep newid campus year meansby asyfe3 asyfe3_p2 asyfe3_p3 tmp_count
	
	sort campus year
	
save ${working_dir}meanSBYs, replace
